#include <stdio.h>
#include <X11/Xlib.h>

/* Variables globales X */
Display *dpy;
Window win;
int scr;
int depth;  /* Profondeur fenetre par defaut */
Visual *visual;  /* Visual par defaut */
unsigned long mask;  /* Attributs fenetres par defaut */
XSetWindowAttributes attr;

/* Contexte graphique */
GC gc;

/* Hauteur et largeur de fenetre */
int wtot,htot;

/* Coordonnee du segment a tracer */
int xs,ys,xd,yd;

/* Indicateurs */
int sel;
int noir =1;

void main(argc,argv)
  int argc;
  char *argv[];
  {
  XEvent event;
  
  /* Connexion serveur X */
  dpy = XOpenDisplay(getenv("DISPLAY"));
  
  /* Ecran, visual, attributs fenetres par defaut */
  scr = (int)XDefaultScreen(dpy);
  visual = XDefaultVisual(dpy,scr);
  depth = XDefaultDepth(dpy,scr);
  mask = CWBackPixel | CWBorderPixel;
  attr.background_pixel = XWhitePixel(dpy,scr);
  attr.border_pixel = XBlackPixel(dpy,scr);
  
  wtot = 300;
  htot = 200;
  
  /* Creation des fenetres drawable */
  win = XCreateWindow(dpy,
                      RootWindow(dpy,scr),
                      0,0,wtot,htot,1,depth,
                      InputOutput,visual,mask,&attr);
                      
  /* Contexte graphique pour affichage en mode normal */
  gc = XCreateGC(dpy,win,0,0);
  XSetForeground(dpy,gc,XBlackPixel(dpy,scr));
   
  /* Recuperation des evenements souris sur la fenetre */
  XSelectInput(dpy,win,ButtonPressMask|ButtonReleaseMask|PointerMotionMask);
  
  /* Affichage fenetre et image source */ 
  XMapWindow(dpy,win);
  sel = 0;
  
  /* Boucle d'evenement */
  while (1)
    {
    XNextEvent(dpy,&event);
    switch(event.type)
      {
      case ButtonPress :
        /* Debut de definition de segment */
        if (event.xbutton.button == 1)
          {
          xs = event.xbutton.x;
          ys = event.xbutton.y;
          sel = 1;
          }
        if (event.xbutton.button == 2) 
          {
          if (noir)
            {
            XSetForeground(dpy,gc,XWhitePixel(dpy,scr));
            noir = 0;
            }
          else
            {
            XSetForeground(dpy,gc,XBlackPixel(dpy,scr));
            noir = 1; 
            }
          }
          break;
      case ButtonRelease :
        /* Fin de definition de segment */
        if (event.xbutton.button == 1)
          {
          sel = 0;
          }
        break;
      case MotionNotify :
        /* Si bouton presse, definition de segment en cours */
        if (sel)
          {
          xd = event.xbutton.x;
          yd = event.xbutton.y;
          /* Tracer ligne */
          XDrawLine(dpy,win,gc,xs,ys,xd,yd);
          xs = xd;
          ys = yd;
          }
        break;
      default :
        break;
      }                         
    }
  }                         
