#include <stdio.h>
#include <X11/Xlib.h>

/* Variables globales X */
Display *dpy;
Window win;
int scr;
int depth;  /* Profondeur fenetre par defaut */
Visual *visual;  /* Visual par defaut */
unsigned long mask;  /* Attributs fenetres par defaut */
XSetWindowAttributes attr;

/* Contexte graphique */
GC gc;

/* Hauteur et largeur de fenetre */
int wtot,htot;

/* Coordonnee du segment a tracer */
int xs,ys,xd,yd;

/* Indicateurs */
int trace = 0;

void main(argc,argv)
  int argc;
  char *argv[];
  {
  XEvent event;
  
  /* Connexion serveur X */
  dpy = XOpenDisplay(getenv("DISPLAY"));
  
  /* Ecran, visual, attributs fenetres par defaut */
  scr = (int)XDefaultScreen(dpy);
  visual = XDefaultVisual(dpy,scr);
  depth = XDefaultDepth(dpy,scr);
  mask = CWBackPixel | CWBorderPixel;
  attr.background_pixel = XWhitePixel(dpy,scr);
  attr.border_pixel = XBlackPixel(dpy,scr);
  
  wtot = 300;
  htot = 200;
  
  /* Creation des fenetres drawable */
  win = XCreateWindow(dpy,
                      RootWindow(dpy,scr),
                      0,0,wtot,htot,1,depth,
                      InputOutput,visual,mask,&attr);
                      
  /* Contexte graphique pour affichage en mode normal */
  gc = XCreateGC(dpy,win,0,0);
  /*XSetForeground(dpy,gc,XBlackPixel(dpy,scr));*/
  XSetForeground(dpy,gc,0x00ffffff);
  XSetFunction(dpy,gc,GXinvert);
   
  /* Recuperation des evenements souris sur la fenetre */
  XSelectInput(dpy,win,ButtonPressMask|ButtonReleaseMask|PointerMotionMask);
  
  /* Affichage fenetre et image source */ 
  XMapWindow(dpy,win);

  /* Boucle d'evenements */
  while (1)
    {
    XNextEvent(dpy,&event);
    switch(event.type)
      {
      /* Evenement d'exposure */
      case ButtonPress :
          xs = event.xbutton.x;
          ys = event.xbutton.y;
          trace = 1;
        break;
      case ButtonRelease :
      	  trace = 0;
        break;
      case MotionNotify :
      	switch(trace) {
      		case 1 :
      			/* Premier trace */
      			trace = 2;
          		xd = event.xbutton.x;
          		yd = event.xbutton.y;
          		XDrawLine(dpy,win,gc,xs,ys,xd,yd);
          		break;
      		case 2 :
      			/* Effacer ancien trait et afficher nouveau */
          		XDrawLine(dpy,win,gc,xs,ys,xd,yd);
          		xd = event.xbutton.x;
          		yd = event.xbutton.y;
          		XDrawLine(dpy,win,gc,xs,ys,xd,yd);
          		break;
          }
        break;
      default :
        break;
      }                         
    }
  }                         
